/* -*- C++ -*-
 *
 * ---------------------------------------------------------------------
 * $Id: command_line_reader.h 23 2003-10-28 02:24:16Z drory $
 * ---------------------------------------------------------------------
 *
 * Copyright (C) 2000-2001 Niv Drory <drory@usm.uni-muenchen.de>
 *                         Claus A. Goessl <cag@usm.uni-muenchen.de>
 *                         Arno Riffeser <arri@usm.uni-muenchen.de>
 *                         Jan Snigula <snigula@usm.uni-muenchen.de>
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA 
 *
 * ---------------------------------------------------------------------
 *
 */

// syntax of config-file must be
// option = value
// value must be of proper type

#ifndef __UTIL_CLREADER__
#define __UTIL_CLREADER__

#include <ltl/config.h>

#include <list>
#include <vector>

#include <cstring>
#include <cctype>

#include <ltl/util/u_exception.h>
#include <ltl/util/option_parser.h>

#ifdef UTIL_USING_NAMESPACE
UTIL_BEGIN_NAMESPACE
using std::string;
using std::list;
using std::vector;
#endif

// Implementation of an OptionReader for command line processing.
//
//
class CommandLineReader : public OptionReader
{
   public:
      CommandLineReader( int argc, char *argv[] );
      virtual ~CommandLineReader();

      virtual string nextOptionName() throw(UException);
      virtual string nextOptionValue( const Option* op ) throw(UException);
      virtual bool   done();

      list<string>   fileArguments();
      vector<string> fileArgumentsVector();
      string progName();

   protected:
      int   argc_;
      char** argv_;

      int   cur_;
      bool  done_;
};

#ifdef UTIL_USING_NAMESPACE
UTIL_END_NAMESPACE
#endif

#endif
