/* 
 * evaluate.cpp
 * main routine for object evaluation pass
 *
 * --------------------------------------------------------------------
 * $Id: evaluate.cpp 2 2002-08-19 17:00:29Z drory $
 * --------------------------------------------------------------------
 *
 * Copyright (C) 2000-2001 Niv Drory <drory@usm.uni-muenchen.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA 
 *
 */

#include "config.h"

#include <list>
#include <iostream>

#include "yoda.h"
#include "object.h"

#include <ltl/marray.h>

typedef MArray<float,2> MImage;
typedef MArray<char,2> MMask;


list<Object*> evaluate( const list<Object*> l, const MImage& I )
{
   list<Object*> l2;

   for( list<Object*>::const_iterator i=l.begin(); i!=l.end(); ++i ) 
   {
      (*i)->evaluate( I ); // background subtracted image !
      if( (*i)->evalgood() ) 
	 l2.push_front( *i );
   }

   cerr << "  " << l2.size() << " objects evaluated successfully.\n";
   return l2;
}
