/*
 * mathutil.cpp
 * Various math utilities
 *
 * --------------------------------------------------------------------
 * $Id: mathutil.cpp 6 2002-10-29 17:17:10Z drory $
 * --------------------------------------------------------------------
 *
 * Copyright (C) 2000-2001 Niv Drory <drory@usm.uni-muenchen.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA 
 *
 */


#include "mathutil.h"

void getmaxsigma( const MArray<int,1>& h, const MArray<float,1>& b,
		  double *max, double *sigma )
{
   int m = h(h.minIndex(1));
   int   n = b.minIndex(1), nbin=1;

   for( MArray<int,1>::ConstIterator i1 = h.begin();
	!i1.done(); ++i1 )
   {
      if( *i1 > m )
      {
	 m    = *i1;
	 nbin = n;
      }
      ++n;
   }
   *max = (double)b(nbin);

   double mm = m;
   
   mm /= sqrt(M_E);
   //float leftbin=h(h.minIndex(1)), rightbin=h(h.maxIndex(1));
   int k1, k2;
   for( k1=nbin; k1>b.minIndex(1); k1-- )
      if( h(k1) <= mm )
	 break;
   for( k2=nbin; k2<b.maxIndex(1); k2++ )
      if( h(k2) <= mm )
	 break;

   *sigma = double(b(k2)-b(k1))/2.0;
}


void getbins( const float minv, const float maxv, MArray<float,1>& b )
{
   float binsize = float(maxv-minv) / float(b.nelements()); 

   float c=0;

   for( MArray<float,1>::Iterator i=b.begin(); !i.done(); ++i )
   {
      *i = minv + (c+.5)*binsize; 
      ++c;
   }
}


